#version 410

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec2 v2TexCoordsIn;
layout (location = 2) in vec3 aNormal;

out vec3 worldPos;
out vec3 worldNormal;
out vec2 uv_MainTex;
out vec4 lightSpacePos;
out vec4 visibleSpacePos;

uniform mat4 m_matrix;   //projection * view * model
uniform mat4 m_model;  // model
uniform mat4 m_lightSpaceMatrix0;
uniform mat4 m_visibleSpaceMatrix;

void main()
{
    uv_MainTex = v2TexCoordsIn;
    gl_Position = m_matrix * vec4(aPos, 1.0);
    worldPos = vec3(m_model * vec4(aPos, 1.0));
    worldNormal = mat3(transpose(inverse(m_model))) * aNormal;

    lightSpacePos = m_lightSpaceMatrix * vec4(worldPos, 1.0);
    visibleSpacePos = m_visibleSpaceMatrix * vec4(worldPos, 1.0);
}
